
\chapter{User Interface}


\section{Command Line Interface}
When you launch a Somewhere 2.0 program on the command line, you can 
add parameters, like this :
\begin{lstlisting}[language=sh]
	java -jar Somewhere.jar PARAMETERS
\end{lstlisting}
For example, if you want to use the {\bf help} command, you can do it like this:
\begin{lstlisting}[language=sh]
	java -jar Somewhere.jar --help
\end{lstlisting}
If you want to specify arguments to this commands, (for example, to give the argument
{\bf console} to the command {\bf help}), you can do it like this:
\begin{lstlisting}[language=sh]
	java -jar Somewhere.jar --help console
\end{lstlisting}
You can also enter several commands, for example :
\begin{lstlisting}[language=sh]
	java -jar Somewhere.jar --help console --showConfiguration
\end{lstlisting}
This command will print help about the command {\em console}, and
print the configuration.

%TODO
TODO : Add details on how to contact a running somewhere program


\section{Command Line Shell}
You can specify the command {\em console} on the command line when launching
Somewhere 2.0 (cf the section above), to launch a console shell, like this:
\begin{lstlisting}[language=sh]
	java -jar Somewhere.jar --console
\end{lstlisting}

You can enter commands like you would do using a {\em bash} or {\em ksh} or
{\em zsh} shell, with shortcut keys like {\bf CTRL-A} to go at the beginning
of the line, or $\uparrow$ and $\downarrow$ to go up and down into the history of
entered commands, or {\bf TAB} to complete one command.
Just use the {\bf Enter} key to execute one command. \\
Each line correspond to one commands. \\
For example, if you want to use the {\bf help} commands, with argument
{\bf pauseCommunication}, you can do it like this:
\begin{lstlisting}[language=sh]
	java -jar Somewhere.jar --console
Console successfully started
15H 51M 49S $ 
15H 51M 49S $ help pauseCommunication
\end{lstlisting}

%TODO
TODO : Add details on how to contact a running somewhere program


\section{List of commands/parameters for Command Line UI Systems}

\subsection{Base commands}
\begin{description}
	\item[addModule [ARGS]] Add modules specified in [ARGS]
	\item[help [ARGS]] Prints help infos about all known commands, if 
		[ARGS] is empty, or about the specified commands in [ARGS]
		elsewise.
	\item[importConfigurationFile [ARGS]] Load the XML Configuration files
		specified in [ARGS]
	\item[modulesList] Show the list of currently loaded modules
	\item[quit] quit Somewhere
	\item[removeModule [ARGS]] Remove modules specified in [ARGS]
	\item[showConfiguration [ARGS]] Show the global configuration, if
		[ARGS] is empty, or show the configuration of the modules 
		specfified in [ARGS], elsewise.
\end{description}

\subsection{Console commands}
\begin{description}
	\item[console] Launch a console Shell
\end{description}

\subsection{Communication commands}
\begin{description}
	\item[listPeers] List the known peers
	\item[listWaitingMessages] List the messages to be sent
	\item[pauseCommunication] Stop all communication. Ie : all
		messages to be sent are not sent, and all messages
		received are put on a stack.
	\item[receiveMessage] Print information about the next message
		to be received. This command do not block waiting : you can
		enter others commands (in particular with the shell)
		while it is waiting for the next message.
	\item[resumeCommunication]
		Resume communications, that were stopped using command 
		\verb!pauseCommunication!
	\item[sendFileMessage DESTINATION FILE-PATH] Send the content
		of a file (whose path is given by \verb!FILE-PATH!) to
		a known peer named \verb!DESTINATION!.
	\item[sendTextMessage DESTINATION MESSAGE-CONTENT] Send a
		specified content (by \verb!MESSAGE-CONTENT!) to
		a known peer named \verb!DESTINATION!.
\end{description}

\subsection{JXTA commands}
\begin{description}
	\item[jxtaAdvertisementsList] List all advertisements, in
		particular those advertised by the local peer.
	\item[jxtaPeerGroupStatus] Print informations about the peer group.
	\item[jxtaPeerStatus] Print informations about the local peer.
\end{description}

\subsection{Plogic commands}
\begin{description}
	\item[loadNewPropositionalInstance PATH] Load a new 
		propositional instance (whose path is \verb!PATH!)
		in place of the old one, if there was one already loaded.
	\item[query [ARGS]] TODO
	\item[showPropositionalInstance] Show a representation
		of the actual propositional instance.
\end{description}


